//
// automatically generated by spin2cpp v1.92 on Thu Jun 11 20:24:36 2015
// spin2cpp --main fs.spin 
//

// s2 : "s2"
// :::::::[ Driver Object for the Scribbler 2 ]:::::::::::::::::::::::::::::::::
/* {
┌───────────────────────────────────────┐
│          Scribbler S2 Object          │
│(c) Copyright 2010 Bueno Systems, Inc. │
│   See end of file for terms of use.   │
└───────────────────────────────────────┘
This object provides both high- and low-level drivers for the
Parallax Scribbler S2 robot.

Version History
───────────────

2010.09.16: Initial Version 1(M) release
2010.09.28: Version 1(N) release:
              Fixed bug in _ee* Spin routines.
              Upped size of sound buffer to 1200.
              Added calibration methods for light sensors.
              Added 1/2 sec. delay to start routine.
2010.10.18:   Added check for zero time in play_tone.
2010.10.25:   Added log response method for light sensors.
2010.10.27: Version 1(O) release:
              Added methods to save default line sensor threshold.
2010.10.28:   Fixed bugs in calibration methods.
2010.11.15: Version 1(P) release:
              Added self-documentation features.
              Added sensitivity setting for obstacle detection.
2010.11.24: Version 1(Q) release:
              Added sample programs to self-documentation.
 */
/* =======[ Introduction ]=========================================================

S2.spin provides low-level drivers for the S2 Robot's various functions, as well as
top-level access functions to interface with those drivers. Driver functions are
separated into four additional cogs:
''
''  1. Analog, button, and LED drivers.
''  2. Motor driver.
''  3. Sound sequencer and synthesizer.
''  4. Microphone envelope detector.
''
Driver #1 is required and is started with the S2 object's main `start method. The
other drivers are optional, depending upon the user's requirements, and have their
own start methods (`start_motors, `start_tones, `start_mic_env). The S2 object's
`stop method stops all driver cogs which have been started.

The analog, button, and LED drivers are the heartbeat of the system. The analog
driver continuously cycles through sixteen analog inputs and updates their states
with a one-millisecond cycle time. The button driver monitors the state
of the S2's single pushbutton and, depending on the user-selected button mode, can
cause it to reset the S2, while displaying the button-press count on the LEDs, and
record the number of button presses in EEPROM for use by the newly-restarted user
program. The LED driver manages the LEDs' polarity and PWMing to provide various
shades and hues from the S2's red/green LEDs and blue power LED. It does this via
the LEDs' shift register port.

 */
// =======[ Constants... ]=========================================================
#include <propeller.h>
#include "s2ABL.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
uint8_t s2ABL::dat[] = {
  0x00, 0xf1, 0xbf, 0xa0, 0x01, 0xed, 0xbf, 0xa0, 0x01, 0xf4, 0xff, 0xa0, 0x1b, 0x2d, 0xfc, 0x54, 
  0x1a, 0x2f, 0xfc, 0x54, 0x07, 0x1c, 0xfc, 0x50, 0x02, 0x40, 0xfe, 0xa0, 0x07, 0x27, 0xbe, 0xa0, 
  0x06, 0x31, 0xbe, 0xa0, 0x06, 0x33, 0xbe, 0xa0, 0x01, 0x32, 0xfe, 0x28, 0x04, 0x20, 0xfe, 0xa0, 
  0xba, 0x94, 0xfd, 0x5c, 0x1e, 0x2f, 0xbe, 0xa0, 0x00, 0x20, 0xfe, 0xa0, 0xba, 0x94, 0xfd, 0x5c, 
  0x17, 0x3d, 0xbe, 0x84, 0xff, 0x3c, 0x7e, 0xc3, 0x16, 0x00, 0x68, 0x5c, 0x19, 0x31, 0xbe, 0x94, 
  0x01, 0x32, 0xfe, 0x2a, 0x0b, 0x00, 0x54, 0x5c, 0x18, 0x01, 0xbc, 0xa0, 0x17, 0x01, 0xbc, 0xa0, 
  0x1d, 0x2d, 0xfc, 0x54, 0x1c, 0x2f, 0xfc, 0x54, 0x06, 0x1c, 0xfc, 0x50, 0x08, 0x40, 0xfe, 0xe4, 
  0xf1, 0x2b, 0xbe, 0xa0, 0x07, 0x2b, 0xbe, 0x80, 0x07, 0x2b, 0xbe, 0xf8, 0xf0, 0x25, 0xbe, 0xa0, 
  0x28, 0x24, 0xfe, 0x80, 0x12, 0x3d, 0xbe, 0x08, 0x01, 0x3c, 0xfe, 0x80, 0x12, 0x3d, 0x3e, 0x08, 
  0xf0, 0x23, 0xbe, 0xa0, 0x34, 0x22, 0xfe, 0x80, 0x01, 0x42, 0xfe, 0x80, 0x11, 0x3d, 0xbe, 0x06, 
  0x58, 0x00, 0x68, 0x5c, 0x02, 0x22, 0xfe, 0x80, 0x1e, 0x21, 0xbe, 0xa0, 0x0c, 0x20, 0xfe, 0x28, 
  0x1e, 0x25, 0xbe, 0xa0, 0x07, 0x24, 0xfe, 0x28, 0x1e, 0x24, 0xfe, 0x60, 0xf0, 0x25, 0xbe, 0x80, 
  0x1e, 0x41, 0xbe, 0xa0, 0x04, 0x40, 0xfe, 0x28, 0x0f, 0x40, 0xfe, 0x60, 0x50, 0x26, 0xfe, 0xa0, 
  0x20, 0x27, 0xbe, 0x2c, 0x1e, 0x29, 0xbe, 0xa0, 0x01, 0x28, 0xfe, 0x28, 0x07, 0x28, 0xfe, 0x60, 
  0xb3, 0x94, 0xfd, 0x5c, 0x03, 0x20, 0x7e, 0x86, 0x42, 0x00, 0x54, 0x5c, 0x1e, 0x3f, 0xbe, 0xa0, 
  0x02, 0xe9, 0xbf, 0x68, 0x01, 0x3c, 0xfe, 0x64, 0xb3, 0x94, 0xfd, 0x5c, 0x02, 0xe9, 0xbf, 0x64, 
  0x1f, 0x3d, 0xbe, 0x84, 0x00, 0x3c, 0xfe, 0x40, 0x12, 0x41, 0xbe, 0x04, 0x20, 0x3f, 0xbe, 0xa0, 
  0x14, 0x3f, 0xbe, 0x28, 0x1f, 0x41, 0xbe, 0x84, 0x08, 0x3c, 0xfe, 0x2c, 0x14, 0x3d, 0xbe, 0x28, 
  0x1e, 0x41, 0xbe, 0x80, 0x12, 0x41, 0x3e, 0x04, 0x27, 0x00, 0x54, 0x5c, 0x08, 0x40, 0xfe, 0x28, 
  0x01, 0x1c, 0x7e, 0x62, 0x0a, 0x3c, 0xd6, 0xa0, 0x0f, 0x3c, 0xea, 0xa0, 0x1e, 0x41, 0x3e, 0x85, 
  0x01, 0x1c, 0xfe, 0x74, 0x27, 0x00, 0x64, 0x5c, 0xf0, 0x25, 0xbe, 0xa0, 0x20, 0x24, 0xfe, 0x80, 
  0x12, 0x41, 0xbe, 0x04, 0x01, 0x40, 0xfe, 0x80, 0x12, 0x41, 0x3e, 0x04, 0x27, 0x00, 0x7c, 0x5c, 
  0xf0, 0x25, 0xbe, 0xa0, 0x2d, 0x24, 0xfe, 0x80, 0x12, 0x45, 0xbe, 0x00, 0xf2, 0x15, 0x3e, 0x61, 
  0x08, 0x1b, 0x8e, 0xa0, 0x01, 0x18, 0xfe, 0x36, 0x01, 0x16, 0x7e, 0x61, 0x01, 0x18, 0x72, 0x82, 
  0x01, 0x16, 0xea, 0x80, 0x0b, 0x3f, 0xbe, 0xa0, 0x01, 0x3e, 0xfe, 0x2a, 0x08, 0x3e, 0xfe, 0x4c, 
  0x01, 0x1a, 0xfe, 0xe1, 0x79, 0x00, 0x78, 0x5c, 0x01, 0x24, 0xfe, 0x84, 0x12, 0x3f, 0x3e, 0x00, 
  0x00, 0x16, 0xfe, 0xa0, 0x02, 0x44, 0x7e, 0x61, 0x79, 0x00, 0x4c, 0x5c, 0x01, 0x3c, 0xfe, 0x0c, 
  0x07, 0x40, 0xfe, 0xa0, 0x20, 0x3d, 0x3e, 0x86, 0x03, 0x40, 0x56, 0x0c, 0x01, 0x40, 0xfe, 0x85, 
  0x6d, 0x00, 0x4c, 0x5c, 0x00, 0x46, 0xfe, 0xa0, 0xcb, 0xa8, 0xfd, 0x5c, 0x1f, 0x3d, 0xbe, 0xa0, 
  0xda, 0xce, 0xfd, 0x5c, 0xf2, 0xf6, 0xfd, 0x5c, 0x00, 0x32, 0xfe, 0xa0, 0xab, 0x64, 0xfd, 0x5c, 
  0x00, 0x12, 0x7e, 0x0c, 0x01, 0x44, 0x7e, 0x61, 0x8b, 0x00, 0x6c, 0x5c, 0x0f, 0x3d, 0xbe, 0xa0, 
  0x1f, 0x3d, 0xbe, 0x28, 0x1f, 0x3d, 0xbe, 0x28, 0x00, 0x32, 0xfe, 0xa0, 0x06, 0x40, 0xfe, 0xa0, 
  0x10, 0x30, 0xfe, 0xa0, 0x01, 0x3c, 0xfe, 0x29, 0x18, 0x33, 0xbe, 0x70, 0x20, 0x30, 0x7e, 0x61, 
  0x1f, 0x30, 0xfe, 0x60, 0x01, 0x30, 0xfe, 0x34, 0x81, 0x40, 0xfe, 0xe4, 0x40, 0x42, 0x7e, 0x61, 
  0x02, 0x44, 0x7e, 0x62, 0x80, 0x32, 0xd6, 0x70, 0xa9, 0x00, 0x7c, 0x5c, 0xf0, 0x25, 0xbe, 0xa0, 
  0x24, 0x24, 0xfe, 0x80, 0x04, 0x40, 0xfe, 0xa0, 0x21, 0x31, 0xbe, 0xa0, 0x0f, 0x30, 0xfe, 0x60, 
  0x01, 0x30, 0xfe, 0x80, 0x12, 0x3d, 0xbe, 0x00, 0x01, 0x24, 0xfe, 0x80, 0x1e, 0x3f, 0xbe, 0xa0, 
  0x04, 0x3e, 0xfe, 0x28, 0x0f, 0x3c, 0xfe, 0x60, 0x1e, 0x27, 0xbe, 0xa0, 0x1f, 0x27, 0xbe, 0x80, 
  0x10, 0x26, 0x7e, 0x85, 0x00, 0x43, 0x4e, 0x62, 0x00, 0x3c, 0xca, 0xa0, 0x00, 0x3e, 0xc6, 0xa0, 
  0x01, 0x3c, 0x7e, 0x86, 0x00, 0x3c, 0xea, 0xa0, 0x01, 0x3e, 0x7e, 0x86, 0x00, 0x3e, 0xea, 0xa0, 
  0x1e, 0x27, 0xbe, 0xa0, 0x1f, 0x27, 0xbe, 0x80, 0x02, 0x32, 0xfe, 0x2c, 0x18, 0x27, 0x3e, 0x85, 
  0xa8, 0x00, 0x70, 0x5c, 0x18, 0x3d, 0x3e, 0x85, 0x01, 0x32, 0xce, 0x68, 0x02, 0x32, 0xf2, 0x68, 
  0x91, 0x40, 0xfe, 0xe4, 0xab, 0x64, 0xfd, 0x5c, 0x1e, 0x00, 0x7c, 0x5c, 0x08, 0x40, 0xfe, 0xa0, 
  0x01, 0x32, 0xfe, 0x29, 0x80, 0xe8, 0xff, 0x70, 0x00, 0xe9, 0xff, 0x68, 0x00, 0xe9, 0xff, 0x64, 
  0xac, 0x40, 0xfe, 0xe4, 0x80, 0xe8, 0xff, 0x64, 0x00, 0x00, 0x7c, 0x5c, 0x01, 0x3c, 0x7e, 0x61, 
  0x1a, 0x2f, 0x8e, 0xa0, 0x1b, 0x31, 0x8e, 0xa0, 0x1c, 0x2f, 0xb2, 0xa0, 0x1d, 0x31, 0xb2, 0xa0, 
  0x01, 0x70, 0x7d, 0x61, 0xbb, 0x00, 0x7c, 0x5c, 0x00, 0x74, 0x7d, 0x61, 0x16, 0x20, 0xfe, 0x2c, 
  0xf4, 0x3d, 0xbe, 0xa0, 0x03, 0x3d, 0xbe, 0x64, 0x10, 0x3d, 0xbe, 0x68, 0x1e, 0xe9, 0xbf, 0xa0, 
  0x16, 0x20, 0xfe, 0x28, 0xf1, 0x2d, 0xbe, 0xa0, 0x13, 0x2d, 0xbe, 0x80, 0x18, 0x2d, 0xbe, 0xf8, 
  0xfc, 0x3d, 0xbe, 0xa4, 0x00, 0x2c, 0xfe, 0xf8, 0xfc, 0x3d, 0xbe, 0x80, 0x17, 0x3d, 0xb2, 0x84, 
  0x00, 0x3c, 0xf2, 0x40, 0xff, 0x3c, 0xf2, 0x44, 0x00, 0x00, 0x7c, 0x5c, 0xe8, 0xe2, 0xfd, 0x5c, 
  0xa2, 0x3c, 0xfe, 0xa0, 0xda, 0xce, 0xfd, 0x5c, 0xcb, 0x00, 0x70, 0x5c, 0x23, 0x3d, 0xbe, 0xa0, 
  0x08, 0x3c, 0xfe, 0x28, 0xda, 0xce, 0xfd, 0x5c, 0x23, 0x3d, 0xbe, 0xa0, 0xda, 0xce, 0xfd, 0x5c, 
  0x00, 0x00, 0x7c, 0x5c, 0x01, 0xaa, 0x7d, 0x61, 0xd8, 0x00, 0x7c, 0x5c, 0x00, 0xae, 0x7d, 0x61, 
  0xff, 0x3c, 0xfe, 0xa0, 0xdb, 0x00, 0x7c, 0x5c, 0x01, 0xb4, 0x7d, 0x61, 0x09, 0x40, 0xfe, 0xa0, 
  0x18, 0x3c, 0xfe, 0x34, 0x01, 0x3c, 0xfe, 0x35, 0x05, 0xed, 0xbf, 0x74, 0xfc, 0xfe, 0xfd, 0x5c, 
  0x04, 0xe9, 0xbf, 0x68, 0xfc, 0xfe, 0xfd, 0x5c, 0xf2, 0x0b, 0x3e, 0x61, 0x04, 0xe9, 0xbf, 0x64, 
  0xfc, 0xfe, 0xfd, 0x5c, 0xdd, 0x40, 0xfe, 0xe4, 0xff, 0x3c, 0xfe, 0x60, 0x00, 0x00, 0x7c, 0x5c, 
  0x05, 0xed, 0xbf, 0x64, 0xfc, 0xfe, 0xfd, 0x5c, 0x04, 0xe9, 0xbf, 0x68, 0x04, 0xed, 0xbf, 0x68, 
  0xfc, 0xfe, 0xfd, 0x5c, 0x05, 0xed, 0xbf, 0x68, 0xfc, 0xfe, 0xfd, 0x5c, 0x04, 0xe9, 0xbf, 0x64, 
  0xfc, 0xfe, 0xfd, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0x04, 0xe9, 0xbf, 0x64, 0xfc, 0xfe, 0xfd, 0x5c, 
  0x05, 0xed, 0xbf, 0x68, 0xfc, 0xfe, 0xfd, 0x5c, 0x04, 0xe9, 0xbf, 0x68, 0xfc, 0xfe, 0xfd, 0x5c, 
  0x05, 0xed, 0xbf, 0x64, 0xfc, 0xfe, 0xfd, 0x5c, 0x04, 0xed, 0xbf, 0x64, 0x00, 0x00, 0x7c, 0x5c, 
  0x34, 0x2c, 0xfe, 0xa0, 0xf1, 0x2d, 0xbe, 0x80, 0x00, 0x2c, 0xfe, 0xf8, 0x00, 0x00, 0x7c, 0x5c, 
  0x1b, 0x34, 0x00, 0x24, 0x80, 0x11, 0xc0, 0x07, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x03, 
  0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x20, 0x00, 0x08, 0x00, 0x00, 0x80, 0x38, 0x01, 0x00, 
  0xe8, 0x03, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xa5, 0x02, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x0e, 0x40, 0x0e, 0x71, 0x0f, 0x62, 0x0e, 0x53, 0x0e, 0x24, 0x0e, 0x15, 
  0x0f, 0xc6, 0x06, 0x0e, 0x66, 0x3f, 0x0e, 0x97, 0x0e, 0xa8, 0x0e, 0xd9, 0x66, 0xea, 0x66, 0xfb, 
  0x47, 0xbc, 0x47, 0x8d, 0x00, 0x00, 
};
// =======[ Public Spin methods... ]===============================================
//
// -------[ Start and stop methods... ]--------------------------------------------
//
// Start and stop methods are used for starting individual cogs or stopping all
// of them at once.
int32_t s2ABL::start(void)
{
  int32_t	i;
  /*  This is the main start routine for S2 object. It stops ALL cogs, so
       IT MUST BE CALLED FIRST, before starting other cogs.
    ''
    '' `Example: s2.start
    ''
    ''     Start s2 object.
    
   */
  stop_all();
  memset( (void *)&(*(uint16_t *)&dat[1088]), 0, sizeof(uint16_t)*40);
  if ((((uint8_t *)&dat[1136])[0] = cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&(*(uint16_t *)&dat[1088]))) + 1)) {
    OUTA = 0x10000000;
    DIRA = 0x10200000;
    _i2c_stop();
    if ((((uint8_t *)&dat[1137])[0] = _ee_rdbyte(EE_RESET_CNT))) {
      _ee_wrbyte(EE_RESET_CNT, 0);
    }
    if (((uint8_t *)&dat[1137])[0] > 8) {
      ((uint8_t *)&dat[1137])[0] = 0;
    }
    set_led(POWER, BLUE);
    delay_tenths(5);
    return -1;
  } else {
    return 0;
  }
}

int32_t s2ABL::stop_all(void)
{
  /*  This method is used to stop all S2 cogs that have been started with the other
       start methods. It is called by `start, but its use is otherwise limited.
    ''
    '' `Example: s2.stop_all
    ''
    ''     Stop all S2 cogs.
    
   */
  if ((*(uint8_t *)&dat[1136])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[1136]), 0) - 1));
  }
  return 0;
}

// -------[ Low-level result methods... ]-------------------------------------------------
/*  The low-level results methods provide access to all the values used and sensed by the Analog/Button/LED cog.
   They can be used to access data which otherwise have no dedicated convenience routines in this object.
 */
int32_t s2ABL::get_results(int32_t index)
{
  /*  General accessor for the Results array: returns the full word value. When applied to ADC results, the word values
       returned include real-time low-pass filtering data in the eight LSBs.
    ''
    ''     `index: The pointer into the Results array. See the "Result array indices" constants for index names.
    ''
    '' `Example: battery_level := s2.get_adc_results(s2#ADC_VBAT)
    ''
    ''     Query the battery voltage and save in `battery_level.
    
   */
  return ((uint16_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[index];
}

int32_t s2ABL::get_adc_results(int32_t index)
{
  /*  General accessor for ADC Results array: returns upper eight bits of word value.
    ''
    ''     `index: The pointer into the ADC Results array. See the "Result array indices" constants for index names.
    ''
    '' `Example: battery_level := s2.get_adc_results(s2#ADC_VBAT)
    ''
    ''     Query the battery voltage and save in battery_level.
    
   */
  return (Shr__(((uint16_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[index], 8));
}

// -------[ Button methods... ]-------------------------------------------------
/*  Button methods control and sense the user's interaction with the S2's push button. */
int32_t s2ABL::button_mode(int32_t led_enable, int32_t reset_enable)
{
  ((uint8_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0x2d] = (LED_ENA & -(led_enable != 0)) | (RST_ENA & -(reset_enable != 0));
  return 0;
}

int32_t s2ABL::button_press(void)
{
  /*  Return `true if the button is down; `false if the button is up.
    ''
    '' `Example: if(s2.button_press)
    ''
    ''     The `if block is executed when the button is down.
    
   */
  return -(((INA >> BUTTON) & 0x1) == 0);
}

int32_t s2ABL::button_count(void)
{
  int32_t result = 0;
  /*  Get the last count of button presses (0 - 8). Then zero the count.
    ''
    '' `Example: button_presses := s2.button_count
    ''
    ''     The varialbe `button_presses is set to the recent button press count, which is then zeroed.
    
   */
  if ((result = ((uint8_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0x2c])) {
    ((uint8_t *)(int32_t)(&(*(uint16_t *)&dat[1088])))[0x2c] = 0;
  }
  return result;
}

int32_t s2ABL::reset_button_count(void)
{
  /*  Return the reset button count (0- 8). Zero indicates a power-on or PC-initiated reset.
    ''
    '' `Example: reset_button_presses := s2.reset_button_count
    ''
    ''     The variable `reset_button_presses is set to the button press count that caused the reset.
    
   */
  return (*(uint8_t *)&dat[1137]);
}

// -------[ LED methods... ]----------------------------------------------------
/*  LED methods control the red/green user LEDs and the blue "power" LED. Except for its hue,
   the so-called "power" LED is programmable like the other three. It is nominally turned on
   when the `start method is called, but it may subsequently be changed to suit the user's
   purposes.
 */
int32_t s2ABL::set_leds(int32_t left_color, int32_t center_color, int32_t right_color, int32_t power_color)
{
  /*  Sets all LEDs for which the color argument <> NO_CHANGE (-1).
       See the above constant list for predefined indices and colors. See also
       `set_led (below) for a definition of the argument values.
    ''
    ''     `left_color, `center_color, `right_color, `power_color: The values to which to set the respective LEDs.
    ''
    '' `Example: s2.set_leds(s2#RED, s2#NO_CHANGE, s2#BLINK_GREEN, s2#OFF)
    ''
    ''     Set LEDs (L to R, and power): RED, no change, blinking GREEN, off.
    
   */
  if (left_color != NO_CHANGE) {
    set_led(LEFT, left_color);
  }
  if (center_color != NO_CHANGE) {
    set_led(CENTER, center_color);
  }
  if (right_color != NO_CHANGE) {
    set_led(RIGHT, right_color);
  }
  if (power_color != NO_CHANGE) {
    set_led(POWER, power_color);
  }
  return 0;
}

int32_t s2ABL::set_led(int32_t index, int32_t color)
{
  int32_t	shift;
  ((uint8_t *)(((int32_t)(&(*(uint16_t *)&dat[1088])) + (LED_BYTES << 1)) + (index & 0x3)))[0] = color;
  return 0;
}

int32_t s2ABL::delay_tenths(int32_t time)
{
  int32_t	time0;
  /*  Time delay in tenths of a second.
    ''
    ''     `tenths: Number of tenths of a second to delay before returning.
    ''
    '' `Example: s2.delay_tenths(20)
    ''
    ''     Wait a couple seconds.
    
   */
  time0 = CNT;
  {
    int32_t _idx__0001;
    int32_t _limit__0002 = time;
    for(_idx__0001 = 1; _idx__0001 <= _limit__0002; _idx__0001 = _idx__0001 + 1) {
      waitcnt((time0 = time0 + (CLKFREQ / 10)));
    }
  }
  return 0;
}

// -------[ EEPROM methods... ]-------------------------------------------------
/*  EEPROM methods allow direct read access to the entire auxiliary EEPROM and direct write access to its user area.
   The user area begins at the address given by the constant `EE_USER_AREA.
 */
int32_t s2ABL::ee_read_byte(int32_t addr)
{
  /*  Read a byte from the auxiliary EEPROM.
    ''
    ''     `addr (0 - 32767): The byte address from which to read.
    ''
    '' `Example: my_data := s2.ee_read_byte($2000)
    ''
    ''     Set `my_data equal to the byte at location $2000 (8192) in the auxiliary EEPROM.
    
   */
  return _ee_rdbyte(addr);
}

int32_t s2ABL::ee_write_byte(int32_t addr, int32_t data)
{
  /*  Write a byte to auxiliary EEPROM.
    ''
    ''     `addr (EE_USER_ADDR - 32767): The address to which the data is written. Writes outside this range are ignored.
    ''
    ''     `data (0 - 255): the byte value to write.
    ''
    '' `Example: s2.ee_write_byte(s2#EE_USER_AREA + 5, 35)
    ''
    ''     Write the value 35 to the sixth byte in the auxiliary EEPROM's user area.
    
   */
  if (addr >= EE_USER_AREA) {
    _ee_wrbyte(addr, data);
    return -1;
  } else {
    return 0;
  }
}

//
//
// =======[ Private Spin methods... ]==============================================
//
// These private methods are used internally and are not accessible to the user.
//
// -------[ Miscellaneous... ]--------------------------------------------------
int32_t s2ABL::_ee_rdblock(int32_t dest_addr, int32_t addr, int32_t size)
{
  int32_t	i, csum;
  /*  Read a block of data, `size bytes long, into `dest_addr, from EEPROM at `addr.
       Read one additional checksum byte, and return `true if checksum is zero;
       `false, otherwise.
    
   */
  csum = _ee_rdbyte((addr + size));
  {
    int32_t _limit__0003 = (size - 1);
    int32_t _step__0004 = 1;
    i = 0;
    if (i >= _limit__0003) _step__0004 = -_step__0004;
    do {
      csum = csum + (((uint8_t *)dest_addr)[i] = _ee_rdbyte((addr + i)));
      i = i + _step__0004;
    } while (((_step__0004 > 0) && (i <= _limit__0003)) || ((_step__0004 < 0) && (i >= _limit__0003)));
  }
  return -((csum & 0xff) == 0);
}

int32_t s2ABL::_ee_wrblock(int32_t src_addr, int32_t addr, int32_t size)
{
  int32_t	i, data, csum;
  int32_t result = 0;
  /*  Write a block of data, `size bytes long, from `src_addr into EEPROM at `addr.
       Write one additional checksum byte at the end.
    
   */
  csum = 0;
  result = -1;
  {
    int32_t _limit__0005 = (size - 1);
    int32_t _step__0006 = 1;
    i = 0;
    if (i >= _limit__0005) _step__0006 = -_step__0006;
    do {
      data = ((uint8_t *)src_addr)[i];
      csum = csum - data;
      result = result & _ee_wrbyte((addr + i), data);
      i = i + _step__0006;
    } while (((_step__0006 > 0) && (i <= _limit__0005)) || ((_step__0006 < 0) && (i >= _limit__0005)));
  }
  result = result & _ee_wrbyte((addr + size), (csum & 0xff));
  return result;
}

int32_t s2ABL::_ee_rdbyte(int32_t addr)
{
  int32_t result = 0;
  /*  Read a byte of data from the EEPROM at `addr.  */
  _i2c_waddr(addr);
  _i2c_start();
  _i2c_wr(163);
  result = _i2c_rd(NAK);
  _i2c_stop();
  return result;
}

int32_t s2ABL::_ee_wrbyte(int32_t addr, int32_t data)
{
  int32_t result = 0;
  /*  Write the byte given by `data to the EEPROM at `addr.  */
  _i2c_waddr(addr);
  result = _i2c_wr(data);
  _i2c_stop();
  return result;
}

int32_t s2ABL::_i2c_waddr(int32_t addr)
{
  /*  Work routine for EEPROM. Wait for EEPROM ready, then write a command, followed by the `addr byte.  */
  do {
    _i2c_start();
  } while (!(_i2c_wr(162)));
  _i2c_wr((Shr__(addr, 8)));
  _i2c_wr((addr & 0xff));
  return 0;
}

int32_t s2ABL::_i2c_rd(int32_t acknak)
{
  int32_t result = 0;
  /*  Work routine for EEPROM. Read the next byte, and send ACK or NAK, depending on `acknak.  */
  {
    int32_t _idx__0007;
    for(_idx__0007 = 1; _idx__0007 <= 8; _idx__0007 = _idx__0007 + 1) {
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      result = (result << 1) | ((INA >> SDA) & 0x1);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA = ((DIRA & 0xdfffffff) | ((-(acknak != 0) & 0x1) << SDA));
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  OUTA &= ~(1<<SCL);
  DIRA &= ~(1<<SDA);
  return result;
}

int32_t s2ABL::_i2c_wr(int32_t data)
{
  int32_t result = 0;
  /*  Work routine for EEPROM. Write the next byte, given by data, and return `true for ACK, `false for NAK.  */
  {
    int32_t _idx__0008;
    for(_idx__0008 = 1; _idx__0008 <= 8; _idx__0008 = _idx__0008 + 1) {
      DIRA = ((DIRA & 0xdfffffff) | ((-(((data = data << 1) & 0x100) == 0) & 0x1) << SDA));
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  result = -(((INA >> SDA) & 0x1) == 0);
  OUTA &= ~(1<<SCL);
  return result;
}

int32_t s2ABL::_i2c_start(void)
{
  /*  Set up an I2C `start condition.  */
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA &= ~(1<<SCL);
  return 0;
}

int32_t s2ABL::_i2c_stop(void)
{
  /*  Set up an I2C `stop condition.  */
  OUTA &= ~(1<<SCL);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA &= ~(1<<SDA);
  return 0;
}

// =======[ License ]===========================================================
/* {
┌──────────────────────────────────────────────────────────────────────────────────────┐
│                            TERMS OF USE: MIT License                                 │                                                            
├──────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this  │
│software and associated documentation files (the "Software"), to deal in the Software │
│without restriction, including without limitation the rights to use, copy, modify,    │
│merge, publish, distribute, sublicense, and/or sell copies of the Software, and to    │
│permit persons to whom the Software is furnished to do so, subject to the following   │
│conditions:                                                                           │
│                                                                                      │
│The above copyright notice and this permission notice shall be included in all copies │
│or substantial portions of the Software.                                              │
│                                                                                      │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,   │
│INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A         │
│PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT    │
│HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF  │
│CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE  │
│OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                                         │
└──────────────────────────────────────────────────────────────────────────────────────┘
 */
